当前位置:首页 > 开发 > 编程语言 > Java > 正文

java异常处理机制

发表于: 2013-08-08   作者:cq520   来源:转载   浏览:
摘要: 异常是程序中的一些错误,但并不是所有的错误都是异常,并且错误有时候是可以避免的。比如说,你用System.out.println(5/0),那么你是因为你用0做了除数,会抛出java.lang.ArithmeticException的异常。 有些异常需要做处理,有些则不需要捕获处理,在下面会详细讲到。 天有不测之风云,人有旦夕祸福,Java的程序代码也如此。在编程过程中,首先应当尽可能去避免错误

异常是程序中的一些错误,但并不是所有的错误都是异常,并且错误有时候是可以避免的。比如说,你用System.out.println(5/0),那么你是因为你用0做了除数,会抛出java.lang.ArithmeticException的异常。 有些异常需要做处理,有些则不需要捕获处理,在下面会详细讲到。

天有不测之风云,人有旦夕祸福,Java的程序代码也如此。在编程过程中,首先应当尽可能去避免错误和异常发生,对于不可避免、不可预测的情况则应考虑异常发生时如何处理。

      而在Java中的异常用对象来表示,Java对异常的处理是按异常分类处理的,不同异常有不同的分类,每种异常都对应一个类型(class),每个异常都对应一个异常(类的)对象。

      异常类从哪里来?有两个来源,一是Java语言本身定义的一些基本异常类型,二是用户通过继承Exception类或者其子类自己定义的异常。Exception 类及其子类是 Throwable 的一种形式,它指出了合理的应用程序想要捕获的条件。

      异常的对象从哪里来呢?有两个来源,一是Java运行时环境自动抛出系统生成的异常,而不管你是否愿意捕获和处理,它总要被抛出!比如除数为0的异常。二是程序员自己抛出的异常,这个异常可以是程序员自己定义的,也可以是Java语言中定义的,用throw 关键字抛出异常,这种异常常用来向调用者汇报异常的一些信息。

异常是针对方法来说的,抛出、声明抛出、捕获和处理异常都是在方法中进行的。

       Java异常处理通过5个关键字trycatchthrowthrowsfinally进行管理。基本过程是用try语句块包住要监视的语句,如果在try语句块内出现异常,则异常会被抛出,你的代码在catch语句块中可以捕获到这个异常并做处理;还有部分系统生成的异常在Java运行时自动抛出。你也可以通过throws关键字在方法上声明该方法要抛出异常,然后在方法内部通过throw抛出异常对象。说到这里,可能很多人都不知道throwsthrow的区别,其实很简单,

        throw用来抛出一个异常,在方法体内。语法格式为:throw 异常对象。 throws用来声明方法可能会抛出什么异常,在方法名后,语法格式为:throws 异常类型1,异常类型2...异常类型n 如下:

 

import java.io.IOException;

public class ThrowsAndThrow {
	public void test(int a,int b)throws IOException,ArrayIndexOutOfBoundsException{
		int c=a/b;
		if(b==0){
			throw new ArithmeticException();
		}
	}
}

 

catch语句可以有多个,用来匹配多个异常,匹配上多个中一个后,执行catch语句块时候仅仅执行匹配上的异常。如果你不理解这句话的意思,可以运行一下下面这段代码:

package 完整的异常处理示例;

import java.io.*;

public class TestException2 {
	public static void main(String args[]){
		int x,y,result;
		x=5;
		int a[]={0};
		try{
			InputStreamReader reader=new InputStreamReader(System.in);
			BufferedReader input=new BufferedReader(reader);
			System.out.println("输入除数:");
			//读取一行中输入的数字
			y=Integer.parseInt(input.readLine());
			result=x/y;
			a[10]=5;
			System.out.println(result);
			System.out.println("发生异常时不会被执行的语句");
		}catch(ArrayIndexOutOfBoundsException e){//数组越界异常
			System.out.println("对数组越界异常进行了处理");
		}catch(ArithmeticException e){
			System.out.println("对算术异常进行了处理");
		}catch(Exception e){
			System.out.println("对异常进行了处理");
			return;
		}
	}
}

 

输入0和输入非0的数之后,它都只执行了匹配的一个异常,至于匹配的顺序,当然是从上到下的。此外,catch的类型是Java语言中定义的或者程序员自己定义的,表示代码抛出异常的类型,异常的变量名表示抛出异常的对象的引用,如果catch捕获并匹配上了该异常,那么就可以直接用这个异常变量名,此时该异常变量名指向所匹配的异常,并且在catch代码块中可以直接引用。

       Java异常处理的目的是提高程序的健壮性,你可以在catchfinally代码块中给程序一个修正机会,使得程序不因异常而终止或者流程发生以外的改变。另外,finally语句先于return语句执行,而不论其先后位置,也不管是否try块出现异常可以通过下面一段代码看出来:

package 完整的异常处理示例;

public class TestException {
	public static void main(String args[]){
		int a=5;
		int b=0;
		int result;
		try{
			result=a/b;
			System.out.println(result);
		}catch(Exception e){
			System.out.println(e.toString());
			System.out.println("异常已经得到处理");
			//结束程序的执行
			return;
		}finally{
			System.out.println("finally语句得到执行");
		}
		System.out.println("这是一个测试语句");
	}
}

 

Java异常处理是Java语言的一大特色,也是个难点,掌握异常处理可以让写的代码更健壮和易于维护

       这里是java异常中最重要和最基本的类,大家有时间的话都可以去研究一下:

       java.lang.Throwable

       java.lang.Exception

       java.lang.RuntimeException

       java.lang.Error

       java.lang.ThreadDeath

 

      下面是这几类以及在API上面的解释:

1Throwable

     Throwable 类是 Java 语言中所有错误或异常的超类。只有当对象是此类(或其子类之一)的实例时,才能通过 Java 虚拟机或者 Java throw 语句抛出。类似地,只有此类或其子类之一才可以是 catch 子句中的参数类型。

两个子类的实例,Error Exception,通常用于指示发生了异常情况。通常,这些实例是在异常情况的上下文中新近创建的,因此包含了相关的信息(比如堆栈跟踪数据)。

 

2Exception

     Exception 类及其子类是 Throwable 的一种形式,它指出了合理的应用程序想要捕获的条件,表示程序本身可以处理的异常。

 

3Error

     Error Throwable 的子类,表示仅靠程序本身无法恢复的严重错误,用于指示合理的

应用程序不应该试图捕获的严重问题。 在执行该方法期间,无需在方法中通过throws

声明可能抛出但没有捕获的 Error 的任何子类,因为Java编译器不去检查它,

也就是说,当程序中可能出现这类异常时,即使没有用try...catch语句捕获它,

也没有用throws字句声明抛出它,还是会编译通过。

 

4RuntimeException

      RuntimeException 是那些可能在 Java 虚拟机正常运行期间抛出的异常的超类。

      Java编译器不去检查它,也就是说,当程序中可能出现这类异常时,即使没有用try...catch语句捕获它,也没有用throws字句声明抛出它,还是会编译通过,这种异常可以通过改进代码实现来避免。

 

5ThreadDeath

     调用 Thread 类中带有零参数的 stop 方法时,受害线程将抛出一个 ThreadDeath 实例。

仅当应用程序在被异步终止后必须清除时才应该捕获这个类的实例。如果 ThreadDeath 被一个方法捕获,那么将它重新抛出非常重要,因为这样才能让该线程真正终止。

如果没有捕获 ThreadDeath,则顶级错误处理程序不会输出消息。

虽然 ThreadDeath 类是“正常出现”的,但它只能是 Error 的子类而不是 Exception 的子类,因为许多应用程序捕获所有出现的 Exception,然后又将其放弃。

 

通过上面的描述,相信大家也都知道了,对于可能出现异常的代码,通常有两种处理办法

第一、在方法中用try...catch语句捕获并处理异常。

第二、对于处理不了的异常或者要转型的异常,在方法的声明处通过throws语句抛出异常。

不过,如果每个方法都是简单的抛出异常,那么在方法调用方法的多层嵌套调用中,Java虚拟机会从出现异常的方法代码块中往回找,直到找到处理该异常的代码块为止然后将异常交给相应的catch语句处理。如果Java虚拟机追溯到方法调用栈最底部main()方法时,仍然没有找到处理异常的代码块,将按照下面的步骤处理

第一、调用异常的对象的printStackTrace()方法,打印方法调用栈的异常信息。

第二、如果出现异常的线程为主线程,则整个程序运行终止;如果非主线程,则终止该线程,其他线程继续运行。这就是为什么我们有些时候出异常了程序仍然会运行,而有些时候却不会。

通过分析思考可以看出,越早处理异常消耗的资源和时间越小,产生影响的范围也越小。

因此,不要把自己能处理的异常也抛给调用者。此外,还有一点,由于finally语句是在任何情况下都必须执行的代码,这样可以保证一些在任何情况下都必须执行代码的可靠性。比如,在数据库查询异常的时候,应该释放JDBC连接等等。finally语句唯一不被执行的情况是方法执行了System.exit()方法。System.exit()的作用是终止当前正在运行的 Java 虚拟机。),此外,finally语句块中不能通过给变量赋新值来改变return的返回值,所以,也建议不要在finally块中使用return语句,没有意义还容易导致错误。

 

最后还应该注意一下异常处理的语法规则:

第一、try语句不能单独存在,可以和catchfinally组成 try...catch...finallytry...catchtry...finally三种结构,catch语句可以有一个或多个,finally语句最多一个,trycatchfinally这三个关键字均不能单独使用。

第二、trycatchfinally三个代码块中变量的作用域分别独立而不能相互访问。如果要在三个块中都可以访问,则需要将变量定义到这些块的外面。

第三、多个catch块时候,Java虚拟机会匹配其中一个异常类或其子类,就执行这个catch块,而不会再执行别的catch块。

第四、throw语句后不允许有紧跟其他语句,因为这些没有机会执行。

第五、如果一个方法调用了另外一个声明抛出异常的方法,那么这个方法要么处理异常,要么声明抛出。

那怎么判断一个方法可能会出现异常呢?一般来说,方法声明的时候用了throws语句,方法中有throw语句,方法调用的方法声明有throws关键字。

 

JavaAPI中为我们提供了大量的异常类,相信你在编码的过程中也经常碰到ArrayIndexOutOfBoundsException以及IOException等等异常,那么我们是否可以自定义异常呢?答案是肯定的,要自定义一个异常的方法也非常简单,如下代码:

 

package 自定义异常;

import java.io.BufferedReader;
import java.io.InputStreamReader;

@SuppressWarnings("serial")
class MyException extends Exception {
	public MyException(){
		super("除数不能为负");
	}
	void test(int y)throws MyException{
		if(y<0)throw new MyException();
	}
}
public class TestException {
	public static void main(String args[]){
		int a,b,result;
		a=5;
		MyException my=new MyException();
		try{
			InputStreamReader reader=new InputStreamReader(System.in);
			BufferedReader input=new BufferedReader(reader);
			System.out.println("请输入一个数");
			b=Integer.parseInt(input.readLine());
			result=a/b;
			my.test(b);
			System.out.println(result);
		}catch(MyException e){
			System.out.println(e.toString());
		}catch(Exception e){
			e.printStackTrace();
			return;
		}
	}
}

 

       进行异常处理自然是要做一些有意义的事情了,比如说为了防止连接阻塞而在发生异常时关闭Socket对象等等,不要捕捉了异常却什么事情都不做哦,打印一下异常的信息也是有作用的。

 

运行时异常和受检查异常

Exception类可以分为两种:运行时异常和受检查异常。

1、运行时异常

RuntimeException类及其子类都被称为运行时异常,这种异常的特点是Java编译器不去检查它,也就是说,当程序中可能出现这类异常时,即使没有用try...catch语句捕获它,也没有用throws字句声明抛出它,还是会编译通过。例如,当除数为零时,就会抛出java.lang.ArithmeticException异常。 但是我们在写代码的时候却不需要try...catch

2、受检查异常

又称强制异常,除了RuntimeException类及其子类外,其他的Exception类及其子类都属于受检查异常,这种异常的特点是要么用try...catch捕获处理,要么用throws语句声明抛出,否则编译不会通过。

3、两者的区别

运行时异常表示无法让程序恢复运行的异常,导致这种异常的原因通常是由于执行了错误的操作。一旦出现错误,建议让程序终止。

受检查异常表示程序可以处理的异常。如果抛出异常的方法本身不处理或者不能处理它,那么方法的调用者就必须去处理该异常,否则调用会出错,连编译也无法通过。当然,这两种异常都是可以通过程序来捕获并处理的,比如除数为零的运行时异常,这一点在本文开头的代码中就已经提到了。

4、运行时错误

Error类及其子类表示运行时错误,这个类与Exception是存在区别的,通常是由Java虚拟机抛出的,JDK中与定义了一些错误类,比如VirtualMachineError OutOfMemoryError,程序本身无法修复这些错误.一般不去扩展Error类来创建用户自定义的错误类。而RuntimeException类表示程序代码中的错误,是可扩展的,用户可以创建特定运行时异常类。

Error(运行时错误)和运行时异常的相同之处是:Java编译器都不去检查它们,当程序运行时出现它们,都会终止运行。

5、解决方案

对于运行时异常,我们不要用try...catch来捕获处理,而是在程序开发调试阶段,尽量去避免这种异常,一旦发现该异常,正确的做法就会改进程序设计的代码和实现方式,修改程序中的错误,从而避免这种异常。捕获并处理运行时异常是好的解决办法,因为可以通过改进代码实现来避免该种异常的发生。

对于受检查异常,自然是老老实实的按照异常处理的方法去处理了,要么用try...catch捕获并解决,要么用throws抛出!

对于Error(运行时错误),不需要在程序中做任何处理,出现问题后,应该在程序以外的地方找问题,然后解决。

 

异常转型和异常链

异常转型在上面已经提到过了,实际上就是捕获到异常后,将异常以新的类型的异常再抛出,这样做一般为了异常的信息更直观!比如:

public void run() throws MyException{

...

try{

...

}catch(IOException e){

...

throw new MyException();

}finally{

...

}

}

异常链,在JDK1.4以后版本中,Throwable类支持异常链机制。Throwable 包含了其线程创建时线程执行堆栈的快照。它还包含了给出有关错误更多信息的消息字符串。最后,它还可以包含 cause(原因):另一个导致此 throwable 抛出的 throwable。它也称为异常链 设施,因为 cause 自身也会有 cause,依此类推,就形成了异常链,每个异常都是由另一个异常引起的。

通俗的说,异常链就是把原始的异常包装为新的异常类,并在新的异常类中封装了原始异常类,这样做的目的在于找到异常的根本原因。

通过Throwable的两个构造方法可以创建自定义的包含异常原因的异常类型:

Throwable(String message, Throwable cause)

构造一个带指定详细消息和 cause 的新 throwable

Throwable(Throwable cause)

构造一个带指定 cause (cause==null ? null :cause.toString())(它通常包含类和 cause 的详细消息)的详细消息的新 throwable

getCause()

返回此 throwable cause;如果 cause 不存在或未知,则返回 null

initCause(Throwable cause)

将此 throwable cause 初始化为指定值。

Throwable的子类Exception中,也有类似的指定异常原因的构造方法:

Exception(String message, Throwable cause)

构造带指定详细消息和原因的新异常。

Exception(Throwable cause)

根据指定的原因和 (cause==null ? null : cause.toString()) 的详细消息构造新异常(它通常包含 cause 的类和详细消息)。

因此,可以通过扩展Exception类来构造带有异常原因的新的异常类。

 

Java异常处理的原则和技巧

1、避免过大的try块,不要把不会出现异常的代码放到try块里面,尽量保持一个try块对应一个或多个异常。

2、细化异常的类型,不要不管什么类型的异常都写成Excetpion

3catch块尽量保持一个块捕获一类异常,不要忽略捕获的异常,捕获到后要么处理,要么转译,要么重新抛出新类型的异常。

4、不要把自己能处理的异常抛给别人。

·      5、不要用try...catch参与控制程序流程,异常控制的根本目的是处理程序的非正常情况。

java异常处理机制

  • 0

    开心

    开心

  • 0

    板砖

    板砖

  • 0

    感动

    感动

  • 0

    有用

    有用

  • 0

    疑问

    疑问

  • 0

    难过

    难过

  • 0

    无聊

    无聊

  • 0

    震惊

    震惊

版权所有 IT知识库 CopyRight © 2009-2015 IT知识库 IT610.com , All Rights Reserved. 京ICP备09083238号